﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace i8014W_Basic_Info_Csharp
{
    public partial class Form1 : Form
    {
        Int16 Slot = 0;
        Int16 CHs = 8;
        Int16 Jumper = 0;
        Int16 Model_Type = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            Tips_list.Items.Add("This is I-8014W series models basic functions demo.");
            Tips_list.Items.Add("Please follow the steps one by one to learn how to operate this model.");
            Tips_list.Items.Add("Step 1 : Select 'Slot index'");
            Slot_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Slot_cmb.Items.Add(string.Format("Slot {0}", i));
            }
            Model_Name_cmb.Items.Clear();
            Model_Name_cmb.Items.Add("I-8014W / I-9014");
            Model_Name_cmb.Items.Add("I-8014CW / I-9014C");
        }

        private void Slot_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = -1;
            Int16 firmware = 0;
            Int16 isofirm = 0;
            Int16 libVer = 0;
            if (Slot_cmb.SelectedIndex != -1)
            {
                //initialize model
                //return 0 means initialize successed
                //return -1 means initialize failed
                ret = pac8014WNet.pac8014W.Init((short)Slot_cmb.SelectedIndex);
                if (ret == 0)
                {
                    Slot = (short)Slot_cmb.SelectedIndex;
                    //get library version
                    libVer = pac8014WNet.pac8014W.LibVersion();
                    Lib_Ver_txt.Text = libVer.ToString("X");
                    //read fpga version
                    firmware = pac8014WNet.pac8014W.FirmwareVer_L1(Slot);
                    FPGA_1_txt.Text = firmware.ToString();
                    //read fpga version
                    isofirm = pac8014WNet.pac8014W.FirmwareVer_L2(Slot);
                    FPGA_2_txt.Text = isofirm.ToString();
                    //get jumper position, for I-8014CW and I-9014C always retuen 0
                    Jumper = pac8014WNet.pac8014W.SingleEndJumper(Slot);
                    if (Jumper == 0)
                    {
                        CHs = 8;
                        Jumper_txt.Text = "Differential";
                    }
                    else
                    {
                        CHs = 16;
                        Jumper_txt.Text = "Single Ended";
                    }

                    Tips_list.Items.Clear();
                    Tips_list.ForeColor = System.Drawing.SystemColors.WindowText;
                    Tips_list.Items.Add("This model initialized successfully.");
                    Tips_list.Items.Add("The information about it are showed in the interfacec");
                    Tips_list.Items.Add("Step 2 : Select 'Model Name'");
                }
                else
                {
                    Tips_list.Items.Clear();
                    Tips_list.ForeColor = Color.Red;
                    Tips_list.Items.Add("Can not find any I-8014W series models");
                    Tips_list.Items.Add("Please check where the model is and select 'Slot index' again");
                    MessageBox.Show("No I-8014W series model at slot " + Slot_cmb.SelectedIndex.ToString());
                }
            }
        }

        private void Model_Name_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            Model_Type = (short)Model_Name_cmb.SelectedIndex;
            Tips_list.Items.Clear();
            Tips_list.Items.Add("The API 'pac8014W.Init' only return the result of initialize");
            Tips_list.Items.Add("User need to know the name of the model,");
            Tips_list.Items.Add("Cause some APIs correspond to different modules");
            Tips_list.Items.Add("Step 3 : Click 'Show' button");
        }

        private void Show_btn_Click(object sender, EventArgs e)
        {
            I_8014W_I_9014 I_8014W_form = new I_8014W_I_9014();
            I_8014CW_I_9014C I_8014CW_form = new I_8014CW_I_9014C();
            if (Model_Type == 0)
            {
                I_8014W_form.Show();
                I_8014W_form.slotIndex = Slot;
                I_8014W_form.maxCh = CHs;
            }
            else if (Model_Type == 1)
            {
                I_8014CW_form.Show();
                I_8014CW_form.slotIndex = Slot;
                I_8014CW_form.maxCh = CHs;
                I_8014CW_form.I_8014CW_I_9014C_Read_Gain_Offset();
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
