﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace i8014W_MagicScan_NonBlock_Csharp
{
    public partial class Form1 : Form
    {
        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        private static extern UInt32 GetTickCount();
        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        private static extern uint GetModuleFileName(IntPtr hModule, System.Text.StringBuilder lpFileName, int nSize);

        short slot = 0;
        short jumper = 0;
        int Scan_Channels = 0;
        public short[] ch_arr = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
        public short[] range_arr = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

        short scan_count = 0;
        float sample_rate = 0;
        short scan_mode = 0;
        short trigger_source = 0;
        short trigger_edge = 0;
        float realsampleRate = 0;
        int target_count = 0;
        int total_scanned_count = 0;
        short[] hexData = new short[10000];

        Thread ScanThread;
        UInt32 T1 = 0, T2 = 0;
        bool ThreadFlag = false;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i = 0;
            int j = 0;
            ListView[] List_arr = { Data_Frame_Display1_lv, Data_Frame_Display2_lv };
            ListViewItem CH_item1 = new ListViewItem();
            ListViewItem CH_item2 = new ListViewItem();
            ListViewItem Range_item1 = new ListViewItem();
            ListViewItem Range_item2 = new ListViewItem();
            ListViewItem[] CH_item = { CH_item1, CH_item2 };
            ListViewItem[] Range_item = { Range_item1, Range_item2 };

            //initialize user interface
            Data_Frame_Display1_lv.Enabled = false;
            Data_Frame_Display1_lv.FullRowSelect = true;
            Data_Frame_Display1_lv.View = View.Details;
            Data_Frame_Display2_lv.Enabled = false;
            Data_Frame_Display2_lv.FullRowSelect = true;
            Data_Frame_Display2_lv.View = View.Details;

            for (i = 0; i < 2; i++)
            {
                CH_item[i].SubItems.Clear();
                CH_item[i].BackColor = System.Drawing.SystemColors.Control;
                CH_item[i].SubItems[0].Text = "Channel";
                for (j = 0; j < 8; j++)
                {
                    CH_item[i].SubItems.Add("--");
                }
                Range_item[i].SubItems.Clear();
                Range_item[i].BackColor = System.Drawing.SystemColors.Control;
                Range_item[i].SubItems[0].Text = "Range";
                for (j = 0; j < 8; j++)
                {
                    Range_item[i].SubItems.Add("--");
                }
                List_arr[i].Clear();
                List_arr[i].BackColor = System.Drawing.SystemColors.Control;
                List_arr[i].Columns.Add("Index", 50, HorizontalAlignment.Center);
                for (j = 0; j < 8; j++)
                {
                    List_arr[i].Columns.Add(string.Format("{0}", i * 8 + j), 60, HorizontalAlignment.Center);
                }
                List_arr[i].Items.Add(CH_item[i]);
                List_arr[i].Items.Add(Range_item[i]);
            }

            Data_Table_lv.FullRowSelect = true;
            Data_Table_lv.View = View.Details;
            Data_Table_lv.Clear();
            Data_Table_lv.Columns.Add("Index", 50, HorizontalAlignment.Center);
            for (i = 0; i < 16; i++)
            {
                Data_Table_lv.Columns.Add(string.Format("CH {0}", i), 60, HorizontalAlignment.Center);
            }

            Model_Name_cmb.Enabled = false;
            Model_Name_cmb.Text = "--";
            Slot_Index_cmb.Enabled = true;
            Scan_Channels_cmb.Enabled = false;
            Trigger_Source_cmb.Enabled = false;
            Trigger_Source_cmb.SelectedIndex = 0;
            Sample_Rate_txt.Enabled = false;
            Jumper_Psoition_lab_b.Text = "--";
            Scan_Mode_cmb.Enabled = false;
            Scan_Mode_cmb.SelectedIndex = 0;
            Trigger_Edge_cmb.Enabled = false;
            Trigger_Edge_cmb.SelectedIndex = 0;
            Sample_Count_txt.Enabled = false;

            Edit_btn.Enabled = false;
            Configure_Magic_Scan_btn.Enabled = false;
            Start_btn.Enabled = false;
            Exit_btn.Enabled = true;

            Tips_list.Items.Clear();
            Tips_list.Items.Add("This is I-8014W series model Magic Scan demo.");
            Tips_list.Items.Add("Please follow the steps one by one to learn how to operate this model.");
            Tips_list.Items.Add("Step 1 : Select 'Slot Index'");
            Slot_Index_cmb.Items.Clear();
            for (i = 0; i < 8; ++i)
            {
                Slot_Index_cmb.Items.Add(string.Format("Slot {0}", i));
            }
            Model_Name_cmb.Items.Clear();
            Model_Name_cmb.Items.Add("I-8014W / I-9014");
            Model_Name_cmb.Items.Add("I-8014CW / I-9014C");
            Scan_Mode_cmb.Items.Clear();
            Scan_Mode_cmb.Items.Add("M1:Standard");
            Scan_Mode_cmb.Items.Add("M2:Sample and Hold");
            Trigger_Source_cmb.Items.Clear();
            Trigger_Source_cmb.Items.Add("Software Command");
            Trigger_Source_cmb.Items.Add("Internal Signal");
            Trigger_Source_cmb.Items.Add("External Signal");
            Trigger_Edge_cmb.Items.Clear();
            Trigger_Edge_cmb.Items.Add("High");
            Trigger_Edge_cmb.Items.Add("Low");
        }

        private void Slot_Index_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = -1;
            Tips_list.Items.Clear();
            //initialize model
            ret = pac8014WNet.pac8014W.Init((Int16)Slot_Index_cmb.SelectedIndex);
            if (ret == 0)
            {
                //return 0 means successful initialization.
                slot = (Int16)Slot_Index_cmb.SelectedIndex;

                //get jumper position, I-8014CW / I-9014C always return 0.
                jumper = pac8014WNet.pac8014W.SingleEndJumper(slot);
                if (jumper == 0)
                {
                    Jumper_Psoition_lab_b.Text = "Differential";
                    Scan_Channels = 8;
                }
                else
                {
                    Jumper_Psoition_lab_b.Text = "Single-Ended";
                    Scan_Channels = 16;
                }
                Model_Name_cmb.Enabled = true;

                Tips_list.Items.Add("This model initialized successful.");
                Tips_list.Items.Add("The API 'pac8014W.Init' only return the result of initialize");
                Tips_list.Items.Add("User need to know the name of the model,");
                Tips_list.Items.Add("Cause some APIs correspond to different modules");
                Tips_list.Items.Add("Step 2 : Select 'Model Name'");

            }
            else
            {
                MessageBox.Show("There is no I-8014W sreies model in slot " + Slot_Index_cmb.SelectedIndex.ToString());
            }
        }

        private void Model_Name_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i = 0;
            Scan_Channels_cmb.Items.Clear();
            Scan_Channels_cmb.Enabled = true;
            for (i = 1; i <= Scan_Channels; i++)
            {
                Scan_Channels_cmb.Items.Add(string.Format("{0} channels", i));
            }
            Scan_Channels_cmb.SelectedIndex = Scan_Channels - 1;
            Trigger_Source_cmb.Enabled = true;
            Sample_Rate_txt.Enabled = true;
            Scan_Mode_cmb.Enabled = true;
            Trigger_Edge_cmb.Enabled = true;
            Sample_Count_txt.Enabled = true;
            Edit_btn.Enabled = true;
            Configure_Magic_Scan_btn.Enabled = true;
            Tips_list.Items.Clear();
            Tips_list.Items.Add("Step 3 : Select 'Scan Channels','Trigger Source','Sample Rate',");
            Tips_list.Items.Add("         'Scan Mode','Trigger Edge','Sample Count' and 'Data Frame'");
            Tips_list.Items.Add("Step 4 : After finished the settings, click 'Configure Magic Scan' button");
        }

        private void Edit_btn_Click(object sender, EventArgs e)
        {

            Data_Frame_Arrangement data_frame = new Data_Frame_Arrangement();
            data_frame.ctrlform = this;
            data_frame.Show();
        }

        private void Scan_Channels_cmb_SelectedIndexChanged(object sender, EventArgs e)
        {
            Show_Data_Frame();
        }

        public void Show_Data_Frame()
        {
            int i = 0;
            int j = 0;
            string[] Range_str = { "+/-10V", "+/-5V", "+/-2.5V", "+/-1.25V", "+/-20mA" };
            ListView[] List_arr = { Data_Frame_Display1_lv, Data_Frame_Display2_lv };
            ListViewItem CH_item1 = new ListViewItem();
            ListViewItem CH_item2 = new ListViewItem();
            ListViewItem Range_item1 = new ListViewItem();
            ListViewItem Range_item2 = new ListViewItem();
            ListViewItem[] CH_item = { CH_item1, CH_item2 };
            ListViewItem[] Range_item = { Range_item1, Range_item2 };
            for (i = 0; i < 2; i++)
            {
                CH_item[i].SubItems.Clear();
                CH_item[i].BackColor = System.Drawing.SystemColors.Control;
                CH_item[i].SubItems[0].Text = "Channel";
                for (j = 0; j < 8; j++)
                {
                    if (i * 8 + j < Scan_Channels_cmb.SelectedIndex + 1)
                    {
                        CH_item[i].SubItems.Add(ch_arr[i * 8 + j].ToString());
                    }
                    else
                    {
                        CH_item[i].SubItems.Add("--");
                    }
                }
                Range_item[i].SubItems.Clear();
                Range_item[i].BackColor = System.Drawing.SystemColors.Control;
                Range_item[i].SubItems[0].Text = "Range";
                for (j = 0; j < 8; j++)
                {
                    if (i * 8 + j < Scan_Channels_cmb.SelectedIndex + 1)
                    {
                        Range_item[i].SubItems.Add(Range_str[range_arr[i * 8 + j]]);
                    }
                    else
                    {
                        Range_item[i].SubItems.Add("--");
                    }
                }
                List_arr[i].Clear();
                List_arr[i].Columns.Add("Index", 50, HorizontalAlignment.Center);
                for (j = 0; j < 8; j++)
                {
                    List_arr[i].Columns.Add(string.Format("{0}", i * 8 + j), 60, HorizontalAlignment.Center);
                }
                List_arr[i].Items.Add(CH_item[i]);
                List_arr[i].Items.Add(Range_item[i]);
            }
        }

        private void Configure_Magic_Scan_btn_Click(object sender, EventArgs e)
        {
            // scanChCount can be 1 ~ 16 (for both Differential and Single Ended)
            // scan channel count must begin at 1
            scan_count = (short)(Scan_Channels_cmb.SelectedIndex + 1);

            sample_rate = Convert.ToSingle(Sample_Rate_txt.Text);
            scan_mode = (short)(Scan_Mode_cmb.SelectedIndex + 1);

            // trigger source 0, start magic scan via polling Mode, software command can only trigger one slot I-8014
            // trigger source 1, start magic scan via internal interrupt signal Mode, internal interrupt signal can trigger all I-8014Ws on slots at the same time.
            // trigger source 2, start magic scan via external trigger signal Mode, extern trigger can also trigger all I-8014Ws on slots at the same time.
            trigger_source = (short)(Trigger_Source_cmb.SelectedIndex);

            // triggerState only related with external DI trigger signal.
            // if triggerState 0, external DI trigger signal must be high to start magic scan (default)
            // if triggerState 1, external DI trigger signal must be low to start magic scan
            trigger_edge = (short)(Trigger_Edge_cmb.SelectedIndex);

            // When Configure Sample Rate of Magic Scan, the result sample rate may be different from input sample rate 
            // Note i8014W_ConfigMagicScan only tell I-8014W how to start magic scan,it will not start magic scan
            // We have to call i8014W_StartMagicScan to start up the magic scan.
            pac8014WNet.pac8014W.ConfigMagicScan(slot, ch_arr, range_arr, scan_count, sample_rate, scan_mode, trigger_source, trigger_edge, ref realsampleRate);

            target_count = Convert.ToInt16(Sample_Count_txt.Text);
            Start_btn.Enabled = true;
            Tips_list.Items.Clear();
            Tips_list.Items.Add("The Magic Scan configured successfully.");
            Tips_list.Items.Add("Step 5: Please go to page 'Start / Show' click 'Start' button.");
        }

        private void Start_btn_Click(object sender, EventArgs e)
        {
            //Send external trigger to I-8014W module
            if (trigger_source == 2)
            {
                MessageBox.Show("Wait for external trigger signal .....");
            }
            total_scanned_count = 0;
            pac8014WNet.pac8014W.StartMagicScan(slot);
            T1 = GetTickCount();
            ScanThread = new Thread(new ThreadStart(ReadFUN));
            ThreadFlag = true;
            ScanThread.Start();
            Exit_btn.Enabled = false;
            Monitor_Timer.Enabled = true;
        }

        private void ReadFUN()
        {
            short ret;
            Int16[] buf = new Int16[4096];
            short readFromFIFO = 0;
            //here is keep reading dara.
            while (ThreadFlag)
            {
                //the data stored in the buf array is the original data
                //they need to be calibrate.
                ret = pac8014WNet.pac8014W.ReadFIFO(slot, buf, (Int16)(target_count - total_scanned_count), ref readFromFIFO);// <=== get data from FIFO ,long* dataCnt
                if (ret == (Int16)pac8014WNet.ErrorCode.FIFO_LATCHED)
                {
                    pac8014WNet.pac8014W.StopMagicScan(slot);
                    ThreadFlag = false;
                    ScanThread.Abort();
                    ScanThread.Join();
                    MessageBox.Show("FIFO latched!, try lower sample rate or less scan channels, please.");
                }

                if (readFromFIFO > 0)
                {
                    for (int i = 0; i < readFromFIFO; i++)
                    {
                        hexData[total_scanned_count + i] = buf[i];
                    }
                    total_scanned_count += readFromFIFO;
                    if (total_scanned_count >= target_count)
                    {
                        pac8014WNet.pac8014W.StopMagicScan(slot);
                        ThreadFlag = false;
                        ScanThread.Abort();
                        ScanThread.Join();
                    }
                }
                T2 = GetTickCount();
                Thread.Sleep(10);
            }
        }

        private void Monitor_Timer_Tick(object sender, EventArgs e)
        {
            //here is keep checking the dara count.
            if (total_scanned_count >= target_count)
            {
                Monitor_Timer.Enabled = false;
                Show_Data();
            }
            else if (total_scanned_count <= target_count && ThreadFlag == false)
            {
                Monitor_Timer.Enabled = false;
                Exit_btn.Enabled = true;
            }
            Total_Scanned_lab_b.Text = total_scanned_count.ToString();
            Scan_Time_lab_b.Text = (T2 - T1).ToString();
            Application.DoEvents();
        }

        public void Show_Data()
        {
            int i = 0;
            int j = 0;
            int index = 0;
            float fval = 0;
            short hval = 0;
            Data_Table_lv.Visible = false;
            if (target_count % scan_count != 0)
            {
                index = (target_count / scan_count) + 1;
            }
            else
            {
                index = target_count / scan_count;
            }


            Data_Table_lv.Clear();
            Data_Table_lv.Columns.Add("Index", 50, HorizontalAlignment.Center);
            for (i = 0; i < scan_count; i++)
            {
                Data_Table_lv.Columns.Add(string.Format("CH {0}", i), 60, HorizontalAlignment.Center);
            }
            for (i = 0; i < index; i++)
            {
                ListViewItem Data_Frame_item = new ListViewItem();
                Data_Frame_item.SubItems.Clear();
                Data_Frame_item.SubItems[0].Text = (i * 8).ToString();
                for (j = 0; j < scan_count; j++)
                {
                    if ((i * scan_count + j) < target_count)
                    {
                        if (Model_Name_cmb.SelectedIndex == 0)
                        {
                            //calibrate data for I-8014W / I-9014
                            if (HEX_Format_ckb.Checked)
                            {
                                pac8014WNet.pac8014W.CalibrateDataHex(slot, range_arr[j], hexData[i * scan_count + j], ref hval);
                                Data_Frame_item.SubItems.Add(hval.ToString("X4"));
                            }
                            else
                            {
                                pac8014WNet.pac8014W.CalibrateData(slot, range_arr[j], hexData[i * scan_count + j], ref fval);
                                Data_Frame_item.SubItems.Add(fval.ToString("F3"));
                            }
                        }
                        else if (Model_Name_cmb.SelectedIndex == 1)
                        {
                            //calibrate data for I-8014CW / I-9014C
                            if (HEX_Format_ckb.Checked)
                            {
                                pac8014WNet.pac8014W.Calibrate_CH_mA_Hex(slot, (short)j, hexData[i * scan_count + j], ref hval);
                                Data_Frame_item.SubItems.Add(hval.ToString("X4"));
                            }
                            else
                            {
                                pac8014WNet.pac8014W.Calibrate_CH_mA(slot, (short)j, hexData[i * scan_count + j], ref fval);
                                Data_Frame_item.SubItems.Add(fval.ToString("F3"));
                            }
                        }
                    }
                    else
                    {
                        Data_Frame_item.SubItems.Add("--");
                    }
                }
                Data_Table_lv.Items.Add(Data_Frame_item);
            }
            Data_Table_lv.Visible = true;
            Exit_btn.Enabled = true;
        }

        private void Exit_btn_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
